package com.mortennobel.openglinfo;

import javax.media.opengl.GL;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLCanvas;
import javax.media.opengl.GLEventListener;
import javax.swing.*;
import java.awt.*;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.Map;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class OpenGLInfo extends JFrame {
    public OpenGLInfo() {
        setTitle("Reading OpenGL Info ...");
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        init();
    }



    private void init(){
        GLCanvas canvas = new GLCanvas();
        canvas.addGLEventListener(new GLEventListener() {
            public void init(GLAutoDrawable drawable) {
                GL gl = drawable.getGL();
                // write out current environment
                final String glVersion = gl.glGetString(GL.GL_VERSION);
                final String glRenderer = gl.glGetString(GL.GL_RENDERER);
                final String glVendor = gl.glGetString(GL.GL_VENDOR);
                final String glShadingLanguageVersion = gl.glGetString(GL.GL_SHADING_LANGUAGE_VERSION);
                final String glExtensions = gl.glGetString(GL.GL_EXTENSIONS);

                SwingUtilities.invokeLater(new Runnable() {
                    public void run() {
                        OpenGLInfo.this.setVisible(false);
                        OpenGLInfo.this.dispose();
                        new OpenGLInfoPanel(glVersion, glRenderer, glVendor, glShadingLanguageVersion, glExtensions);
                    }
                });

            }

            public void display(GLAutoDrawable drawable) {}

            public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height) {}
            public void displayChanged(GLAutoDrawable drawable, boolean modeChanged, boolean deviceChanged) {}
        });
        getContentPane().add(canvas);
        setVisible(true);
    }

    public static void main(String[] args) {
        new OpenGLInfo();
    }
}
